#include <kosSyst.h>
#include <kosFile.h>
#include "core.h"

void eButtonClick(int id) {

}

//  
void draw_rectangle(int x, int y, int sizex, int sizey, int color) {
	x = x*65536+sizex;
	y = y*65536+sizey;
	__asm{
		push 13
		pop eax
		mov ebx, x
		mov ecx, y
		mov edx, color
		int 0x40
	}
}

//  DLL
dll_import* load_dll(char* path) {
	dll_import* result;
	__asm{
		push 68
		pop eax
		mov ebx, 19
		mov ecx, path
		int 0x40
		mov result, eax
	}
	
	return result;
}

//     STack
 
//  
template <typename T>
Stack<T>::Stack(int maxSize) :
    size(maxSize) //  
{
    stackPtr = new T[size]; //    
    top = 0; //    ;
}
 
//  
template <typename T>
Stack<T>::Stack(const Stack<T> & otherStack) :
    size(otherStack.getStackSize()) //  
{
    stackPtr = new T[size]; //     
    top = otherStack.getTop();
 
    for(int ix = 0; ix < top; ix++)
        stackPtr[ix] = otherStack.getPtr()[ix];
}
 
//   
template <typename T>
Stack<T>::~Stack()
{
    delete [] stackPtr; //  
}
 
//     
template <typename T>
inline void Stack<T>::push(const T &value)
{
    //   
    //assert(top < size); //        

    stackPtr[top++] = value; //    
}
 
//     
template <typename T>
inline T Stack<T>::pop()
{
    //   
    //assert(top > 0); //       0
 
    stackPtr[--top]; //    
}
 
//   n-    
template <class T>
inline const T &Stack<T>::Peek(int nom) const
{
  //
  //assert(nom <= top);
 
  return stackPtr[top - nom]; //  n-  
}
 
//    
template <typename T>
inline void Stack<T>::printStack()
{
    //for (int ix = top - 1; ix >= 0; ix--)
       //cout << "|" << setw(4) << stackPtr[ix] << endl;
}
 
//   
template <typename T>
inline int Stack<T>::getStackSize() const
{
    return size;
}
 
//     (  )
template <typename T>
inline T *Stack<T>::getPtr() const
{
    return stackPtr;
}
 
//   
template <typename T>
inline int Stack<T>::getTop() const
{
    return top;
}

EventAction::EventAction() {
	lastHandlerId = 0;
}

void EventAction::add(void (*handler)()) {
	handlers[lastHandlerId] = handler;
	lastHandlerId++;
}

void Event::addHandler(int action, void (*handler)()) {
	if (actions[action] == NULL) {
		actions[action] = new EventAction;
	}

	actions[action]->add(handler);
}

void Event::call(int action) {
	if (actions[action] == NULL) return;
	int i;
	//void (*hnd)();

	for (i=0;i<30;i++) {
		if (actions[action]->handlers[i]) actions[action]->handlers[i]();
		//if (hnd != NULL) hnd();
    }
}

void Window::update() {
	draw(false);
}

void Window::draw() {
	draw(false);
}

void Window::draw(bool flagUpdate) {
	if (flagUpdate) kos_WindowRedrawStatus(1);

	kos_DefineAndDrawWindow(x,y,sizeX,sizeY, mainAreaType,mainAreaColour,headerType,headerColour,(Dword)header);

	int i = 0;

	for (i=0;i<50;i++) {
		if (buttons[i] != NULL) buttons[i]->draw();
		if (labels[i] != NULL) labels[i]->draw();
	}

	this->call(EVENT_DRAW);

	if (flagUpdate) kos_WindowRedrawStatus(2);
}

Window::Window() {
	x = 10;
	y = 10;
	sizeX = 500;
	sizeY = 500;
	mainAreaType = 0x33;
	mainAreaColour = COLOR_WHITE;
	headerType = 0;
	headerColour = COLOR_RED;
	header = (Dword)"Window";

	lastButtonId = 0;
	lastLabelId = 0;
}

void Window::waitForEvent() {
	int k_event;

	while(k_event=kos_WaitForEvent()) {
		switch (kos_WaitForEvent()) {
			case EM_WINDOW_REDRAW:
				draw();
			break;
			case EM_KEY_PRESS:
				Byte keyCode;
				kos_GetKey(keyCode);
				lastKeyPressCode = keyCode;

				this->call(EVENT_KEY_PRESS);
			break;
			case 3:
				Dword buttonId;
				kos_GetButtonID(buttonId);
				
				clickButtonId = (int)buttonId;

				if (buttonId < 50 && buttons[buttonId] != NULL) {
					buttons[buttonId]->call(EVENT_BUTTON_CLICK);
				}

				if (buttonId == 1) {
					this->call(EVENT_WINDOW_CLOSE);
					kos_ExitApp();
				}

			break;
		}
	}
}

int Window::addControl(int type, Button* btn) {
	buttons[lastButtonId] = btn;
	lastButtonId++;
	
	return (lastButtonId-1);
}

int Window::addControl(int type, Label* lbl) {
	labels[lastLabelId] = lbl;
	lastLabelId++;
	
	return (lastLabelId-1);
}

Button::Button() {
	x = 0;
	y = 0;
	sizeX = 30;
	sizeY = 10;
	id = 0;
	color = COLOR_RED;
	hidden = false;
	onclick = eButtonClick;
}

void Button::draw() {
	if (!hidden) kos_DefineButton(x, y, sizeX, sizeY, id, color );
	this->call(EVENT_DRAW);
}

Label::Label() {
	x = 0;
	y = 0;
	id = 0;
	color = COLOR_BLACK;
	hidden = false;
	fontType = 0x80;
	text = "Test";
	textlen = 0;
}

void Label::draw() {
	if (!hidden) kos_WriteTextToWindow(x, y, fontType, color, text, textlen);
	this->call(EVENT_DRAW);
}