#define COLOR_RED 0xFF0000
#define COLOR_GREEN 0x008000
#define COLOR_BLUE 0x0000FF

#define COLOR_AQUA 0x00FFFF
#define COLOR_BLACK 0x000000
#define COLOR_FUCHSIA 0xFF00FF
#define COLOR_GRAY 0x808080
#define COLOR_LIME 0x00FF00
#define COLOR_MAROON 0x800000
#define COLOR_NAVY 0x000080
#define COLOR_OLIVE 0x808000
#define COLOR_PURPLE 0x800080
#define COLOR_SILVER 0xC0C0C0
#define COLOR_TEAL 0x008080
#define COLOR_WHITE 0xFFFFFF
#define COLOR_YELLOW 0xFFFF00

void draw_rectangle(int x, int y, int sizex, int sizey, int color);
void draw_offcut();

typedef struct {
char    *name ;
void    *data ;
} dll_import ;

dll_import* load_dll(char* path);

#define CONTROL_BUTTON 1
#define CONTROL_LABEL 2

#define EVENT_DRAW 0
#define EVENT_BUTTON_CLICK 1
#define EVENT_KEY_PRESS 2
#define EVENT_WINDOW_CLOSE 3

template <typename T>
class Stack
{
private:
    T *stackPtr;                      //   
    const int size;                   //     
    int top;                          //    
public:
    Stack(int = 30);                  //      10 
    Stack(const Stack<T> &);          //  
    ~Stack();                         // 
 
    inline void push(const T & );     //     
    inline T pop();                   //        
    inline void printStack();         //    
    inline const T &Peek(int ) const; // n-    
    inline int getStackSize() const;  //   
    inline T *getPtr() const;         //    
    inline int getTop() const;        //      
};

class EventAction {
public:
	int type;
	//Stack<void (*)()> handlers; 
	void (*handlers[30])();
	int lastHandlerId;

	EventAction();
	void add(void (*handler)());
};

class Event {
public:
	//void (*handlers[100])();
	EventAction* actions[30];
	
	int lastEventType;

	void addHandler(int action, void (*handler)());
	void call(int action);
};


class Control : public Event {
public:
	void draw();
};

class Button : public Control {
public:
	Word x,y,sizeX,sizeY;
	Dword id;
	Dword color;
	bool hidden;

	Button();

	void (*onclick)(int);

	void on();
	//void onclick();
	void draw();
};

class Label : public Control {
public:
	Word x,y;
	Dword id;
	Dword color;
	bool hidden;
	Byte fontType;
	char* text;
	Dword textlen;

	Label();

	void on();
	void draw();
};

class Window : public Event {
public:
	Word x,y,sizeX,sizeY;
	Byte mainAreaType;
	Dword mainAreaColour;
	Byte headerType;
	Dword headerColour;
	Dword header;

	Button* buttons[50];
	int lastButtonId;
	Label* labels[50];
	int lastLabelId;

	Byte lastKeyPressCode;
	int clickButtonId;

	Window();

	void update();
	void draw(bool flagUpdate);
	void draw();
	void drawControls();
	void waitForEvent();

	int addControl(int type, Button*);
	int addControl(int type, Label*);
};