#include <kosSyst.h>
#include <kosFile.h>
#include "core.h"

//  
const char header[] = "HelloWorld test";
//  
Window* win = new Window();

//    
void buttonclick() {
	win->buttons[0]->x = 20;
	win->buttons[0]->y = 20;

	win->update();
}

void window_key_press() {
	switch (win->lastKeyPressCode) {
		case 'w':
			win->buttons[0]->y--;
		break;

		case 's':
			win->buttons[0]->y++;
		break;

		case 'a':
			win->buttons[0]->x--;
		break;

		case 'd':
			win->buttons[0]->x++;
		break;
		
		default:
		break;
	}

	char a = static_cast<char>(win->lastKeyPressCode);

	win->labels[0]->text = &a;
	win->update();
}

void kos_Main() {
	win->header = (Dword)"Window";

	// 
	Button* btn = new Button;
	btn->x = 10;
	btn->y = 10;
	btn->sizeX = 30;
	btn->sizeY = 10;
	btn->id = 0;
	btn->color = COLOR_RED;

	btn->addHandler(EVENT_BUTTON_CLICK, buttonclick);

	//  
	Button* exitBtn = new Button;
	exitBtn->hidden = true;
	exitBtn->id = 1;

	// 
	Label* lbl = new Label;
	lbl->x = 10;
	lbl->y = 50;
	lbl->id = 0;
	lbl->text = "Hello";

	//     
	win->addControl(CONTROL_BUTTON, btn);
	win->addControl(CONTROL_BUTTON, exitBtn);
	win->addControl(CONTROL_LABEL, lbl);

	win->addHandler(EVENT_KEY_PRESS, window_key_press);

	//  
	win->draw();
	//   
	win->waitForEvent();
}